// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/StringList.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__STRING_LIST__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__STRING_LIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/string_list__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StringList_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StringList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StringList_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::StringList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::StringList_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::StringList_Request>()
{
  return "rai_interfaces::srv::StringList_Request";
}

template<>
inline const char * name<rai_interfaces::srv::StringList_Request>()
{
  return "rai_interfaces/srv/StringList_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::StringList_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rai_interfaces::srv::StringList_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rai_interfaces::srv::StringList_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StringList_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: string_list
  {
    if (msg.string_list.size() == 0) {
      out << "string_list: []";
    } else {
      out << "string_list: [";
      size_t pending_items = msg.string_list.size();
      for (auto item : msg.string_list) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StringList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: string_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.string_list.size() == 0) {
      out << "string_list: []\n";
    } else {
      out << "string_list:\n";
      for (auto item : msg.string_list) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StringList_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::StringList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::StringList_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::StringList_Response>()
{
  return "rai_interfaces::srv::StringList_Response";
}

template<>
inline const char * name<rai_interfaces::srv::StringList_Response>()
{
  return "rai_interfaces/srv/StringList_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::StringList_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::StringList_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::StringList_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::StringList>()
{
  return "rai_interfaces::srv::StringList";
}

template<>
inline const char * name<rai_interfaces::srv::StringList>()
{
  return "rai_interfaces/srv/StringList";
}

template<>
struct has_fixed_size<rai_interfaces::srv::StringList>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::StringList_Request>::value &&
    has_fixed_size<rai_interfaces::srv::StringList_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::StringList>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::StringList_Request>::value &&
    has_bounded_size<rai_interfaces::srv::StringList_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::StringList>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::StringList_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::StringList_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__STRING_LIST__TRAITS_HPP_
